/////////////////
// PS_INT.h		:	ͨ·㷨ӿڶ
// PS_INT.h		:	General path searching algorithm interface definition
//
// 汾0010		:	һžʮʮһ
// v0010		:	Oct.31.1997
// v0020		:	Dec.9.1997
//
// д			:	л
// written by	:	JianHua Xie
//
// 		:	Visual C++ 4.0
// Compiler		:	Visual C++ 4.0
//
// Ȩ			:	ǰ޹˾	1997
// Copyright(C)	:	WayAhead Co. Ltd.		1997
//
/////////////////
//
// ļͨ·Ҫݽṹ߱ṩĺӿڣ
// 㷨ṩĵڡ
//

// v0010		:	original version
// v0020		:	renamed QueryResult() to GetDirResult()
//				:	added GetPosResult(), GetImmediateStatus(), IncreaseFind()
//

#ifndef __PS_INT_H__
#define __PS_INT_H__

#ifndef BOOL
#define BOOL	int
#endif

//------------------------------------------------------------------------------
//******************************************************************************
// µͺ Ӧ ɵʵֲṩ㷨,
// һȱʡʵ֡
//******************************************************************************
//------------------------------------------------------------------------------

/////////////////////
// ͣ

// Ϊ˽ʡڴ棬ЩӦþʹռڴС C ͡
//
typedef char			PS_Dir;		// ƶ
typedef unsigned char	PS_DirMask;	// ƶ

typedef int				PS_Cost;	// ƶ

/////////////////////
// 
const PS_Dir	PS_DIR_COUNT	= 8;		// ƶĿ
const PS_Dir	PS_DIR_NONE		= -1;		// Чƶ

const PS_DirMask PS_ALL_DIR_MASK = (1 << PS_DIR_COUNT)-1;	// ƶֵ

#include <pshpack1.h>
/////////////////////
// PS_Posͼλ (Map position)
//     ýṹʵӦɵṩһȽϺĶ塣
//     ·㷨ڲֻʹıȽϺӴֵ洢, ˲
// ֪ʵʶΡûʹóΪٶϵҪ
//
struct PS_Pos {
	short x; // ͼ X 
	short y; // ͼ Y 

	/////////////////////
	// ȽϺ:
	//		a, b			: ҪȽϵλ
	//		RETURN			:  -- ʾȣ -- ʾȡ
	friend BOOL operator== (const PS_Pos& a, const PS_Pos& b);

	/////////////////////
	// Ӵֵ:
	//		pos				: ҪӴֵ PS_Pos
	//		RETURN			: pos Ӵֵ
	friend unsigned HashValue(const PS_Pos& pos);
};
/////////////////////
#include <poppack.h>

/////////////////////
// PS_Pos ȽϺʵ
//
inline BOOL operator== (const PS_Pos& a, const PS_Pos& b)
{
#if 1
	ASSERT(sizeof(PS_Pos) == sizeof(int));
	return *(int*)&a == *(int*)&b;
#else
	return a.x == b.x && a.y == b.y;
#endif
}

/////////////////////
// PS_Pos Ӵֵʵ
//
inline unsigned HashValue(const PS_Pos& pos)
{
	return pos.x * 9 ^ pos.y * 5;
}

//------------------------------------------------------------------------------
//******************************************************************************
// µͺ ɵʵֲṩ㷨
//******************************************************************************
//------------------------------------------------------------------------------

/////////////////////
// PS_Control: ·ƽӿڳ (searching control interface abstract class)
//     ʵ֡PathSrchView.cpp һʵӡ
//
class PS_Control {
public:
	// Ƿڸλͣ
	//
	// pos		λ
	// 		   -- ʾڸλͣ
	//			   -- ʾڸλͣ
	//
	virtual BOOL CanStayHere(PS_Pos pos) = 0;

	// ӸλðķƶһλãƶĿ
	// λƶλʱԺԵķ
	//
	// pos		λ
	// dir		ƶ
	// pNewPos	λ
	// pMoveCostƶ
	// pSkipDirsԺԵķ
	// 		 -- ʾԽƶ
	//			   -- ʾܽƶ  pNewPos, pMoveCost, pSkipDirs ֵ
	//
	virtual BOOL Translate(PS_Pos pos, PS_Dir dir, 
		PS_Pos* pNewPos, PS_Cost *pMoveCost, PS_DirMask *pSkipDirs) = 0;

	// λõĿ
	//
	// pos		λ
	// 		λõĿ
	//			: --- ظԴﵽѰ·Ч ---
	//
	virtual PS_Cost CalcEstimateCost(PS_Pos pos) = 0;

	// λǷĿ
	//
	// pos		λ
	// cost		ɿʼλƶλѻ˶Ĵ
	// 		 -- λѾĿλ ·ֹҵ·
	//			     -- λòĿλ
	//
	virtual BOOL IsBestPos(PS_Pos pos, PS_Cost cost) = 0;
};
/////////////////////

//------------------------------------------------------------------------------
//******************************************************************************
// µͺ㷨ʵʵֲṩ
//******************************************************************************
//------------------------------------------------------------------------------

/////////////////////
// PS_Interface: ·ӿڳ (Path searching interface abstract class)
//     㷨ṩĹڶ塣ʵ X_PS.h, X_PS.cpp С
//
class PS_Interface {
public:
	/////////////////////
	// ͹(Destructor)
	//		
	virtual ~PS_Interface();

	// ӸλÿʼѰ·
	//
	// posSrc	ʼλ
	// pControl	·
	// cDepth	 0 ʾ󣬽ֱҵһ·пԵλöʹ
	// 		0  -- δҵĿ·
	//			1  -- ҵ˵Ŀ·
	//			-1 -- ʼλþĿλ
	//
	virtual int FindPath(PS_Pos posSrc, PS_Control* pControl, unsigned cDepth = 0) = 0;

	// ȡ·Ѱҽ  FindPath() ֮ã
	//
	// paDirs	ƶ򻺳
	// cSize	ĴС PS_Dir Ϊλ
	// 		-1 ʾĵã
	//			   paDirs Ϊ NULL ʱƶĿ 0 ʾƶ
	//			   paDirs Ϊ NULL ʱ
	//			     -- ʾ޴paDirs ǰ ƶĿ ֵЧ
	//				   -- ʾ paDirs 뿪ʼ cSize 
	//
	virtual unsigned GetDirResult(PS_Dir *paDirs, unsigned cSize) = 0;
	virtual unsigned GetPosResult(PS_Pos *paPos, unsigned cSize) = 0;		//v0020

	// ȡм״̬ǰδʵ
	virtual unsigned GetImmediateStatus(void *lpImmStatus, unsigned cSize) = 0;	//v0020
	// Ѱңǰδʵ
	virtual int IncreaseFind(const void *lpImmStatus, unsigned cSize,
							 PS_Control* pControl, unsigned cDepth = 0) = 0;

	// ϴѰ·
	//
	virtual void FlushResult() = 0;

	// ͷʱҪڴ棬ڴĹ
	//
	virtual void PackMemory() = 0;
};
/////////////////////
 
//  PS_Interface ͹
//
inline PS_Interface::~PS_Interface()
{
}

/////////////////////
// PS_New: ڴ沢һ PS_Interface
//		޲
//		RETURN				: һ´ PS_Interface
// WARNING:
//     Ӧ C++  delete ͷ PS_Interface磺
//----
//			PS_Interface *pFinder = PS_New();
//			.....
//			delete pFinder;
//---- 
extern PS_Interface *PS_New(void);

#endif /* __PS_INT_H__ */
