/////////////////
// X_MF.cpp		:	ͼ㷨һʵ
// X_MF.cpp		:	An implemention of map filling algorithm
//
// 汾0010		:	һžʮһ
// v0010		:	Nov.6.1997
// v0020		:   Nov.18.1997
//
// д			:	л
// written by	:	JianHua Xie
//
// 		:	Visual C++ 4.0
// Compiler		:	Visual C++ 4.0
//
// Ȩ			:	ǰ޹˾	1997
// Copyright(C)	:	WayAhead Co. Ltd.		1997
//
/////////////////
//
// ļ˵ͼһʵ֡
//
// WARNING:	ʵֶڵӹϵֻ·ʱܺܺõؽд
//			ǻûз㷨ʧܣܼУӣ
//			ǲԻȫ
//
// Ҫͷļ	: X_TMPL.hMF_INT.h
// Compile request	: X_TMPL.hMF_INT.h
//
// Ҫļ	: ׼ C/C++ 
// Link request		: standard C/C++ library
//

#include "stdafx.h"

#ifndef _INC_STDDEF
#include <stddef.h>	// for size_t
#endif

#ifndef _INC_STDLIB
#include <stdlib.h>	// for rand()
#endif

#include "MF_INT.h"
#include "X_TMPL.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

////////////////////////////////////////////////////////////////////////////////

//  XMapFill:
//		ͼ㷨ľʵ
//
class XMapFill {
protected:
	// ͼصĴ״̬
	//
	enum XPieceStatus { 
		usValidated,	// ѾЧ
		usValidating,	// ҪȷЧ
	};

	// ͼؽṹ
	//
	struct XPiece {
		short			x, y;		// 
		XPiece*			HashNext;	// Ӵָ
		XPiece*			Next;		// ָ
		XPieceStatus	Status;		// ״̬
	};

	// ĸӽṹ
	//	ע⣺
	//		 (2*X, 2*Y),   (2*X+1, 2*Y), 
	//		   (2*X, 2*Y+1), (2*X+1, 2*Y+1)
	//		ʾͼ (X,Y) ĸ
	//
	struct XCell {
		short		x, y;		// 
		XCell*		HashNext;	// Ӵָ
		XCell*		Next;		// ָ
		MF_Class	Class;		// δ
	};

	// ԭʼͼݣ
	//
	struct XOrgInfo {
		short		x, y;		// 
		XOrgInfo*	HashNext;	// Ӵָ
		MF_Class	Cells[4];	// ĸӵĵδ
	};

	// ͼص״̬Ϣ
	//
	struct XPieceInfo {
		MF_Class	Cells[4];		// ĸӵĵδ
		char		Modified[4];	// ־ʾԶ㷨޸Ĺ
	};

	// ͼص״̬ϸϢ
	//
	struct XDetailInfo {
		MF_Class Classes[4];		// ֵĵδ
		int      Count;				// ֵĵδĸ
		int      MustExistCount;	// ѱıĵδĸ
	};

	// ӴձͰС
	//
	enum { 
		XCELL_BACKET_SIZE  = 64,	// 
		XPIECE_BACKET_SIZE = 16,	//
		XORGINFO_BACKET_SIZE = 16,	//
	};

	// ͼ
	//
	XIMapFillControl *m_pControl;

	// Ҫɢھӵĸ
	// Ƚ (FILO, ൱ڶջ)
	XCell *m_pPropagateList;		

	// ҪЧͼ
	// Ƚȳ (FIFO, ൱ڶ)
	XPiece *m_pValidateList;			
	XPiece **m_ppValidateListLast;

	// ڴ
	//
	XStructAllocator<XCell, 16>	m_Cells;
	XStructAllocator<XPiece, 8>	m_Pieces;
	XStructAllocator<XOrgInfo, 8>	m_OrgInfos;

	// ӴͰ
	//
	XCell *m_apCellBacket[XCELL_BACKET_SIZE];
	XPiece *m_apPieceBacket[XPIECE_BACKET_SIZE];
	XOrgInfo *m_apOrgInfoBacket[XORGINFO_BACKET_SIZE];

protected:
	XCell *AddCell(int x, int y, MF_Class cls);
	XCell *FindCell(int x, int y) const;

	XPiece *AddPiece(int x, int y);
	XPiece *FindPiece(int x, int y) const;

	const XOrgInfo *GetPieceOrgInfo(int x, int y);
	void GetPieceInfo(int x, int y, XPieceInfo& rPieceInfo);
	static void AnalyzePieceInfo(const XPieceInfo& rInfo, XDetailInfo& rDetail);

	void PushToPropList(XCell*);
	XCell *PopupFromPropList();

	void AddValidatePiece(int x, int y);

	void PushToValidateList(XPiece*);
	XPiece *PopupFromValidateList();

	void Flush();
	void Init();

protected:
	void SetCellClass(int x, int y, MF_Class cls);
	void ForceSetCellClass(int x, int y, MF_Class cls);
	void SetCellClassEx(int x, int y, MF_Class cls);

	void Propagate(XCell *pCell);		// ɢھ
	void ValidatePiece(XPiece *pPiece);	// ȷͼ

public:
	XMapFill();
	~XMapFill();

	void Cleanup();

	int	AutoMapFill(int x, int y, MF_Class cls, int size, XIMapFillControl *ctrl);
};

////////////////////////////////////////////////////////////////////////////////

inline static unsigned HashValue(int x, int y)
//  (x, y), Ӵֵ
{
	return x * 5 ^ y * 9;
}

////////////////////////////////////////////////////////////////////////////////

inline void XMapFill::PushToPropList(XCell *pCell)
// һӼ뵽ɢ
{
	ASSERT(pCell->Next == NULL);

	pCell->Next = m_pPropagateList;
	m_pPropagateList = pCell;
}

inline XMapFill::XCell *XMapFill::PopupFromPropList()
// ɢȡһӣƳɢ
{
	XCell *pCell = m_pPropagateList;
	if (pCell != NULL) {
		m_pPropagateList = pCell->Next;
		pCell->Next = NULL;
	}
	
	return pCell;
}

inline void XMapFill::PushToValidateList(XPiece *pPiece)
// һͼؼ뵽Ч
{
	ASSERT(pPiece->Next == NULL);

	*m_ppValidateListLast = pPiece;
	m_ppValidateListLast = &pPiece->Next;
}

inline XMapFill::XPiece *XMapFill::PopupFromValidateList()
// ЧȡһͼأƳЧ
{
	XPiece *pPiece = m_pValidateList;
	if (pPiece != NULL) {
		m_pValidateList = pPiece->Next;
		if (m_pValidateList == NULL)
			m_ppValidateListLast = &m_pValidateList;
		pPiece->Next = NULL;
	}

	return pPiece;
}

////////////////////////////////////////////////////////////////////////////////

void XMapFill::Init()
// ʼӴձ
{
	int i;
	for (i = 0; i < XCELL_BACKET_SIZE; i++)
		m_apCellBacket[i] = NULL;
	for (i = 0; i < XPIECE_BACKET_SIZE; i++)
		m_apPieceBacket[i] = NULL;
	for (i = 0; i < XORGINFO_BACKET_SIZE; i++)
		m_apOrgInfoBacket[i] = NULL;

	m_pPropagateList = NULL;
	m_pValidateList = NULL;
	m_ppValidateListLast = &m_pValidateList;

	m_pControl = NULL;
}

XMapFill::XMapFill()
// XMapFill 캯
{
	Init();
}

XMapFill::~XMapFill()
// XMapFill ͹
{
	Cleanup();
}

void XMapFill::Flush()
// ʼڴ
{
	m_Cells.Flush();
	m_Pieces.Flush();
	m_OrgInfos.Flush();

	Init();
}

void XMapFill::Cleanup()
// ͷзڴ
{
	m_Cells.Cleanup();
	m_Pieces.Cleanup();
	m_OrgInfos.Cleanup();

	Init();
}

XMapFill::XCell *XMapFill::FindCell(int x, int y) const
// ӴձвΪ (x,y) ĸ
{
	XCell *pCell = m_apCellBacket[HashValue(x, y) % XCELL_BACKET_SIZE];

	while (pCell) {
		if (pCell->x == x && pCell->y == y)
			break;
		pCell = pCell->HashNext;
	}

	return pCell;
}

XMapFill::XCell *XMapFill::AddCell(int x, int y, MF_Class cls)
// һӣΪ (x,y) Ϊ cls뵽Ӵձ
{
	ASSERT(FindCell(x, y) == NULL);

	XCell *pCell = m_Cells.Alloc();
	pCell->x = x;
	pCell->y = y;
	pCell->Class = cls;
	pCell->Next = NULL;
	XCell **pEntry = &m_apCellBacket[HashValue(x, y) % XCELL_BACKET_SIZE];
	pCell->HashNext = *pEntry;
	*pEntry = pCell;

	return pCell;
}

XMapFill::XPiece *XMapFill::FindPiece(int x, int y) const
// ӴձвΪ (x,y) ͼ
{
	XPiece *pPiece = m_apPieceBacket[HashValue(x, y) % XPIECE_BACKET_SIZE];

	while (pPiece) {
		if (pPiece->x == x && pPiece->y == y)
			break;
		pPiece = pPiece->HashNext;
	}

	return pPiece;
}

XMapFill::XPiece *XMapFill::AddPiece(int x, int y)
// һͼأΪ (x,y) 뵽Ӵձ
{
	ASSERT(FindPiece(x, y) == NULL);

	XPiece *pPiece = m_Pieces.Alloc();
	pPiece->x = x;
	pPiece->y = y;
	// pPiece->Status = usValidating;
	pPiece->Next = NULL;
	XPiece **pEntry = &m_apPieceBacket[HashValue(x, y) % XPIECE_BACKET_SIZE];
	pPiece->HashNext = *pEntry;
	*pEntry = pPiece;

	return pPiece;
}

const XMapFill::XOrgInfo *XMapFill::GetPieceOrgInfo(int x, int y)
// ȡͼ (x,y) ԭʼ
{
	XOrgInfo **pEntry = &m_apOrgInfoBacket[HashValue(x, y) % XORGINFO_BACKET_SIZE];

	XOrgInfo *pOrgInfo = *pEntry;
	while (pOrgInfo != NULL) {
		if (pOrgInfo->x == x && pOrgInfo->y == y)
			break;
		pOrgInfo = pOrgInfo->HashNext;
	}

	if (pOrgInfo == NULL) {
		pOrgInfo = m_OrgInfos.Alloc();
		pOrgInfo->x = x;
		pOrgInfo->y = y;
		pOrgInfo->HashNext = *pEntry;
		*pEntry = pOrgInfo;

		m_pControl->GetMapData(x, y, pOrgInfo->Cells);
	}

	return pOrgInfo;
}

void XMapFill::GetPieceInfo(int x, int y, XPieceInfo& rPieceInfo)
// ȡͼ (x,y) ״̬Ϣ
{
	int needOrgInfo = 0;

	for (int i = 0; i < 4; i++) {
		XCell *pCell = FindCell(x*2+(i&1), y*2+(i>>1));
		if (pCell != NULL) {
			rPieceInfo.Cells[i] = pCell->Class;
			rPieceInfo.Modified[i] = TRUE;
		} else {
			rPieceInfo.Modified[i] = FALSE;
			needOrgInfo++;
		}
	}

	if (needOrgInfo != 0) {
		const XOrgInfo *pOrgInfo = GetPieceOrgInfo(x, y);
		for (int i = 0; i < 4; i++) {
			if (! rPieceInfo.Modified[i])
				rPieceInfo.Cells[i] = pOrgInfo->Cells[i];
		}
	}
}

int	XMapFill::AutoMapFill(int x, int y, MF_Class cls, int size, XIMapFillControl *ctrl)
// Զͼ
{
	ASSERT(size >= 0);

	XCell *pCell;
	XPiece *pPiece;

	// ʼ
	//
	Flush();
	m_pControl = ctrl;

	for (int j = 0; j < size; j++) {
		for (int i = 0; i < size; i++) {
			ForceSetCellClass((x+i)*2+0, (y+j)*2+0, cls);
			ForceSetCellClass((x+i)*2+1, (y+j)*2+0, cls);
			ForceSetCellClass((x+i)*2+0, (y+j)*2+1, cls);
			ForceSetCellClass((x+i)*2+1, (y+j)*2+1, cls);
		}
	}

	// ⣺
	//
	for (;;) {
		while ((pCell = PopupFromPropList()) != NULL) 
			Propagate(pCell);

		if ((pPiece = PopupFromValidateList()) != NULL) 
			ValidatePiece(pPiece);
		else
			break;
	}

	// 
	//
	for (size_t i = 0; i < m_Pieces.GetCount(); i++) {
		XPiece *pPiece = m_Pieces.Get(i);

		ASSERT(pPiece->Next == NULL);
		ASSERT(pPiece->Status == usValidated);

		XPieceInfo info;
		GetPieceInfo(pPiece->x, pPiece->y, info);
#ifdef _DEBUG
		for (int j = 0; j < 4; j++) {
			if (info.Modified[j])
				break;
		}
		ASSERT(j < 4);
#endif
		m_pControl->SetMapData(pPiece->x, pPiece->y, info.Cells);
	}

	// 
	//
	m_pControl = NULL;
	return 0;
}

void XMapFill::SetCellClass(int x, int y, MF_Class cls)
// øӵĵ
{
	if (!m_pControl->IsValidatePos(x/2, y/2))
		return;

	XCell *pCell = FindCell(x, y);
	if (pCell == NULL) {
		const XOrgInfo *pOrgInfo = GetPieceOrgInfo(x/2, y/2);
		if (pOrgInfo->Cells[(x&1) + (y&1)*2] != cls) {
			pCell = AddCell(x, y, cls);
			PushToPropList(pCell);
		}
	} else {
		ASSERT(pCell->Class == cls);
		return;
	}
}

void XMapFill::ForceSetCellClass(int x, int y, MF_Class cls)
// ǿøӵĵ
{
	if (!m_pControl->IsValidatePos(x/2, y/2))
		return;

	XCell *pCell = FindCell(x, y);
	if (pCell == NULL) {
		pCell = AddCell(x, y, cls);
		PushToPropList(pCell);
	} else {
		ASSERT(pCell->Class == cls);
		return;
	} 
}

void XMapFill::SetCellClassEx(int x, int y, MF_Class cls)
// øӵĵΣɢ
{
	if (!m_pControl->IsValidatePos(x/2, y/2))
		return;

	XCell *pCell = FindCell(x, y);
	if (pCell == NULL) {
		const XOrgInfo *pOrgInfo = GetPieceOrgInfo(x/2, y/2);
		if (pOrgInfo->Cells[(x&1) + (y&1)*2] != cls) {
			pCell = AddCell(x, y, cls);
			AddValidatePiece(x/2, y/2);
		}
	} else {
		ASSERT(pCell->Class == cls);
		return;
	}
}

void XMapFill::AddValidatePiece(int x, int y)
// ҪЧͼ
{
	XPiece *pPiece = FindPiece(x, y);
	if (pPiece == NULL) {
		pPiece = AddPiece(x, y);
		pPiece->Status = usValidating;
		PushToValidateList(pPiece);
	} else {
		// the pPiece is Validating or Validated.
		if (pPiece->Status != usValidating) {
			// the pPiece is Validated, but we must Validate it again
			ASSERT(pPiece->Status == usValidated);
			pPiece->Status = usValidating;
			PushToValidateList(pPiece);
		} else {
#ifdef _DEBUG
			XPiece *p = m_pValidateList;
			while (p && p != pPiece)
				p = p->Next;
			ASSERT(p != NULL);
#endif
		}
	}
}

void XMapFill::Propagate(XCell *pCell)
// һӵĵɢھ
{
	MF_Class cls = pCell->Class;
	int x = pCell->x, y = pCell->y;

	int dx = x & 1, dy = y & 1;
	if (dx == 0) dx--;
	if (dy == 0) dy--;

	SetCellClassEx(x+dx, y, cls);
	SetCellClassEx(x, y+dy, cls);
	SetCellClassEx(x+dx, y+dy, cls);
  
	AddValidatePiece(x/2, y/2);
} 

inline static MF_Class __fastcall
ChooseClassFromIntermediate(XIMapFillControl *pControl, MF_Class fixed, MF_Class var)
{
	ASSERT(fixed != var);
	ASSERT(! pControl->IsAllowDirectUnite(fixed, var));

	MF_Class cls = pControl->FindBestIndirectUnite(fixed, var);

	ASSERT(pControl->IsAllowDirectUnite(fixed, cls));

	return cls;
}

static MF_Class __fastcall
ChooseClass1Hard(XIMapFillControl *pControl, MF_Class fixed, MF_Class var1, MF_Class var2)
{
	MF_Class cls1 = pControl->FindBestIndirectUnite(var1, fixed);
	MF_Class cls2 = pControl->FindBestIndirectUnite(var2, fixed);

	MF_Class intermediate;

	if (cls1 == cls2) {
		if (pControl->IsAllowDirectUnite(fixed, cls1))
			return cls1;
		else
			intermediate = cls1;
	} else if (cls1 == var2) {
		intermediate = cls1;
	} else if (cls2 == var1) {
		intermediate = cls2;
	} else {
		ASSERT(FALSE);	// !!!??? Lesowe
		intermediate = cls1;
	}

	return ChooseClassFromIntermediate(pControl, fixed, intermediate);
}

static MF_Class __fastcall
ChooseClass1(XIMapFillControl *pControl, MF_Class fixed, MF_Class var1, MF_Class var2)
{
	ASSERT(fixed != var1 && var1 != var2 && var2 != fixed);

	if (pControl->IsAllowDirectUnite(fixed, var1)) {
		if (pControl->IsAllowDirectUnite(fixed, var2)) {
			// ӹϵֻ·ʱ
#ifndef _DEBUG
			ASSERT(FALSE);	// !!!
#endif
			return fixed;
		} else
			return var1;
	} else {
		if (pControl->IsAllowDirectUnite(fixed, var2))
			return var2;
		else
			return ChooseClass1Hard(pControl, fixed, var1, var2);
	}
}

static MF_Class __fastcall
ChooseClass2Hard(XIMapFillControl *pControl, MF_Class fixed1, MF_Class fixed2, MF_Class var)
{
	if (pControl->FindBestIndirectUnite(fixed1, var) == fixed2) {
		if (pControl->FindBestIndirectUnite(fixed2, var) == fixed1) {
			ASSERT(FALSE);	// !!!
			return fixed2;
		} else
			return fixed2;
	} else {
		if (pControl->FindBestIndirectUnite(fixed2, var) == fixed1)
			return fixed1;
		else {
			ASSERT(FALSE);	// !!!
			return fixed1;
		}
	}
}

static MF_Class __fastcall
ChooseClass2(XIMapFillControl *pControl, MF_Class fixed1, MF_Class fixed2, MF_Class var)
{
	ASSERT(fixed1 != fixed2 && fixed2 != var && var != fixed1);
	ASSERT(pControl->IsAllowDirectUnite(fixed1, fixed2));

	if (pControl->IsAllowDirectUnite(fixed1, var)) {
		if (pControl->IsAllowDirectUnite(fixed2, var)) {
			// ӹϵֻ·ʱ
			ASSERT(FALSE);	// !!!
			return fixed1;
		} else
			return fixed1;
	} else {
		if (pControl->IsAllowDirectUnite(fixed2, var))
			return fixed2;
		else
			return ChooseClass2Hard(pControl, fixed1, fixed2, var);
	}
}

void XMapFill::ValidatePiece(XPiece *pPiece)	
// ЧͼصĺԣʱıΪͼ
{
	ASSERT(pPiece->Status == usValidating);

	pPiece->Status = usValidated;

	int x = pPiece->x, y = pPiece->y;

	XPieceInfo pieceInfo;
	GetPieceInfo(x, y, pieceInfo);

	XDetailInfo detailInfo;
	AnalyzePieceInfo(pieceInfo, detailInfo);

	ASSERT(detailInfo.Count >= 1 && detailInfo.Count <= 4);
	ASSERT(detailInfo.MustExistCount >= 1);
	
#ifdef _DEBUG
	ASSERT(detailInfo.MustExistCount <= 2);
#endif

	MF_Class newClass;

	switch (detailInfo.Count) {
	case 1: 
		return;
 
	case 2:
		if (m_pControl->IsAllowDirectUnite(detailInfo.Classes[0], detailInfo.Classes[1]))
			return;
		ASSERT(detailInfo.MustExistCount <= 1);

		newClass = ChooseClassFromIntermediate(m_pControl, detailInfo.Classes[0], detailInfo.Classes[1]);
		break;

	case 3:
		ASSERT(detailInfo.MustExistCount == 1 || detailInfo.MustExistCount == 2);

		if (detailInfo.MustExistCount == 1)
			newClass = ChooseClass1(m_pControl, detailInfo.Classes[0], detailInfo.Classes[1], detailInfo.Classes[2]);
		else
			newClass = ChooseClass2(m_pControl, detailInfo.Classes[0], detailInfo.Classes[1], detailInfo.Classes[2]);
		break;

//	case 4:
	default:
		ASSERT(detailInfo.MustExistCount == 2);

		newClass = ChooseClass2(m_pControl, detailInfo.Classes[0], detailInfo.Classes[1], detailInfo.Classes[2]);
		break;
	}

	for (int i = 0; i < 4; i++) {
		if (!pieceInfo.Modified[i] && pieceInfo.Cells[i] != newClass)
			SetCellClass(x*2+(i&1), y*2+(i>>1), newClass);
	}
}

void XMapFill::AnalyzePieceInfo(const XPieceInfo& rInfo, XDetailInfo& rDetail)
// ͼصϢ
{
	int i, j;
	MF_Class theClass;

	int count = 0;

	for (i = 0; i < 4; i++) {
		if (rInfo.Modified[i]) {
			theClass = rInfo.Cells[i];
			for (j = 0; j < count; j++) {
				if (rDetail.Classes[j] == theClass)
					break;
			}

			if (j >= count) {
				rDetail.Classes[count] = theClass;
				count++;
			}
		}
	}

	rDetail.MustExistCount = count;

	for (i = 0; i < 4; i++) {
		if (!rInfo.Modified[i]) {
			theClass = rInfo.Cells[i];
			for (j = 0; j < count; j++) {
				if (rDetail.Classes[j] == theClass)
					break;
			}

			if (j >= count) {
				rDetail.Classes[count] = theClass;
				count++;
			}
		}
	}

	rDetail.Count = count;
}

////////////////////////////////////////////////////////////////////////////////

//  XMF_Imp:
//		XIMapFill ľʵ
//
class XMF_Imp : public XIMapFill {
protected:
	XMapFill m_MapFill;

public:
	XMF_Imp();
	~XMF_Imp();

public:
	virtual int	AutoMapFill(XIMapFillControl *ctrl, int x, int y, MF_Class cls, int size = 1);
	virtual void PackMemory();
};

XMF_Imp::XMF_Imp()
: m_MapFill()
{
}

XMF_Imp::~XMF_Imp()
{
}

int	XMF_Imp::AutoMapFill(XIMapFillControl *ctrl, int x, int y, MF_Class cls, int size)
{
	return m_MapFill.AutoMapFill(x, y, cls, size, ctrl);
}

void XMF_Imp::PackMemory()
{
	m_MapFill.Cleanup();
}

////////////////////////////////////////////////////////////////////////////////

XIMapFill* MF_Create(void)
// ڴ沢һ XIMapFill
{
	return new XMF_Imp();
}

////////////////////////////////////////////////////////////////////////////////

#if 0
/*
// еһʵַδɡңӿҪһ޸ġ
//
inline BOOL IsValidatePiecePos(int x, int y)
{
	return m_pControl->IsValidPos(x, y);
}

inline BOOL IsValidateCellPos(int x, int y)
{
	return m_pControl->IsValidPos(x, y)		
		|| m_pControl->IsValidPos(x-1, y)
		|| m_pControl->IsValidPos(x, y-1)	
		|| m_pControl->IsValidPos(x-1, y-1);
}

void CheckPieceMidified(int x, int y)
{
	if (!IsValidatePiecePos(x, y))
		return;

	if (FindModifiedPiece(x, y))
		return;

	const XPieceInfo *pPieceInfo = GetOrgInfo(x, y);
	for (int i = 0; i < 4; i++) {
		XCell *pCell = FindCell(x+(i&1), y+(i>>1));
		if (pCell != NULL && pCell->Validated && pCell->Class != pPieceInfo->Cells[i]) {
			DoAddModifiedPiece(x, y);
			break;
		}
	}
}

void AddModifiedUint(int x, int y)
{
	if (!IsValidatePiecePos(x, y))
		return;

	if (!FindModifiedPiece(x, y))
		DoAddModifiedPiece(x, y);
}

void PushToValidateList(int x, int y)
{
	if (!IsValidateCellPos(x, y))
		return;

	MF_Cell *pCell = FindCell(x, y);
	if (pCell == NULL) 
		pCell = AddCell(x, y);

	if (!pCell->Validated)
		DoPushToValidateList(pCell);
}

void SetCell(int x, int y, MF_Class cls)
{
	if (!IsValidateCellPos(x, y))
		return;

	MF_Cell *pCell = FindCell(x, y);
	if (pCell == NULL) 
		pCell = AddCell(x, y);

	ASSERT(pCell->Validated == FALSE);
	pCell->Validated = TRUE;
	pCell->Class = cls;

	for (int j = -1; j <= 1; i++) {
		for (int i = -1; i <= 1; i++) {
			if (i != 0 || j != 0)
				PushToValidateList(x+i, y+j);
		}
	}

	for (int i = 0; i < 4; i++)
		CheckPieceMidified(x-(i&1), y-(i>>1));
}
 
void AutoMapFill(int x, int y, MF_Class cls, int size = 1)
{
	ASSERT(size > 0);

	XCell *pCell;

	int i, j;

	for (j = 0; j < size; j++) {
		for (i = 0; i < size; i++) {
			AddModifiedPiece(x+i, y+j);
		}
	}

	for (j = 0; j <= size; j++) {
		for (i = 0; i <= size; i++) {
			SetCell(x+i, y+j, cls);
		}
	}

	while ((pCell = PopupFromValidateList()) != NULL) {
		ValidateCell(pCell);
	}
}

struct XCellGroupInfo {
	MF_Class Class[9];
	char AllowModified[9];
};

void GetCellGroupInfo(int x, int y, XCellGroupInfo& info)
{
	for (int j = -1; j <= 1; i++) {
		for (int i = -1; i <= 1; i++) {
			MF_Cell *cell = FindCell(x+i, y+j);
			if (cell) {
				info.Class[(j+1)*3+(i+1)] = cell->Class;
				info.AllowModified[(j+1)*3+(i+1)] = FALSE;
			} else {
				info.Class[(j+1)*3+(i+1)] = GetOrgCellClass(x+i, y+j);
				info.AllowModified[(j+1)*3+(i+1)] = TRUE;
			}
		}
	}
}

void ValidateCell(XCell *pCell)
{
	ASSERT(pCell->Validated == FALSE);

	int x = pCell->x, y = pCell->y;

	XCellGroupInfo info;
	GetCellGroupInfo(x, y, info);
}
*/
#endif
