#include <windows.h>

#include <assert.h>
#define ASSERT assert

#include <stdlib.h>	// for rand()

#include "MF_INT.h"

class XMF_Control : public XIMapFillControl {
public:
	XMF_Control();

public:
	// override XIMapFillControl virtual's
	//
	virtual BOOL IsAllowDirectUnite(MF_Class class1, MF_Class class2);
	virtual MF_Class FindBestIndirectUnite(MF_Class from, MF_Class to);

	virtual BOOL IsValidatePos(int x, int y);

	virtual void GetMapData(int x, int y, MF_Class aClass[4]);
	virtual void SetMapData(int x, int y, const MF_Class aClass[4]);
};

// 0ݵ
// 1
// 2ˮ
// 3
// 4ɽ

static const GROUND_FIRST = GROUND_CA;
static const GROUND_LAST = GROUND_SD;

static const MF_Class x_IndirectUnite[5][5] = {
	{	-2,	-1,	 1,	-1,	 1, },
	{	-1, -2, -1,  0, -1, },
	{    1, -1, -2,  1,  1, },
	{	-1,  0,  0, -2,  0, },
	{	 1, -1,  1,  1, -2, },
};

static const MF_Chass x_DirectUnite[4][2] = {
	{ GROUND_TD, GROUND_CA, },
	{ GROUND_CA, GROUND_ZL, },
	{ GROUND_SD, GROUND_TD, },
	{ GROUND_SH, GROUND_TD, },
};

static const char x_DirToVal[16] = {
	0, 2, 10, 14, 8, 12, 13, 4, 5, 7, 1, 3, 11, 9, 6, 15,
};

static const char x_ValToDir[16] = {
	0, 10, 1, 11, 7, 8, 14, 9, 4, 13, 2, 12, 5, 6, 3, 15,
};

static void UnpackGround(const MAP_GROUND_DATA_STRUCT& groundData, MF_Class aClass[4])
{
	if (groundData.nDir == 0) {
		for (int i = 0; i < 4; i++)
			aClass[i] = groundData.nType;
	} else {
		ASSERT(groundData.nDir >= 1 && groundData.nDir <= 14);

		int bits = x_DirToVal[groundData.nDir];
		int i;

		for (i = 0; i < sizeof(x_DirectUnite) / sizeof(x_DirectUnite[0]); i++) {
			if (x_DirectUnite[i][0] == groundData.nType)
				break;
		}
		ASSERT(i < sizeof(x_DirectUnite) / sizeof(x_DirectUnite[0]));
	
		MF_Class class0 = x_DirectUnite[i][0];
		MF_Class class1 = x_DirectUnite[i][1];
		for (i = 0; i < 4; i++) {
			aClass[i] = bits & 1 ? class1 : class0;
			bits >>= 1;
		}
	}
}

static void PackGround(MAP_GROUND_DATA_STRUCT& groundData, const MF_Class aClass[4])
{
	int i;
	int class0, class1;

	class0 = class1 = -1;
	for (i = 0; i < 4; i++) {
		ASSERT(aClass[i] >= GROUND_FIRST && aClass[i] <= GROUND_LAST);
		if (aClass[i] != class0 && aClass[i] != class1) {
			if (class0 == -1)
				class0 = aClass[i];
			else {
				ASSERT(class1 == -1);
				class1 = aClass[i];
			}
		}
	}

	groundData.nAttr = 0;
	groundData.nFrame = rand() * 8 / (RAND_MAX+1);	// !!! ֡仯

	if (class1 == -1) {
		groundData.nType = class0;
		groundData.nDir = 0;
		return;
	}

	ASSERT(x_IndirectUnite[class0][class1] == -1);

	int bits = 0;
	for (i = 0; i < 4; i++) {
		bits >>= 1;
		if (aClass[i] != class0)
			bits |= 8;
	}
	ASSERT(bits >= 1 && bits <= 14);

	for (i = 0; i < sizeof(x_DirectUnite) / sizeof(x_DirectUnite[0]); i++) {
		if (class0 == x_DirectUnite[i][0] && class1 == x_DirectUnite[i][1]) {
			break;
		} else if (class0 == x_DirectUnite[i][1] && class1 == x_DirectUnite[i][0])  {
			bits ^= 15;
			break;
		}
	}
	ASSERT(i < sizeof(x_DirectUnite) / sizeof(x_DirectUnite[0]));

	groundData.nType = x_DirectUnite[i][0];
	groundData.nDir = x_ValToDir[bits];
}

XMF_Control::XMF_Control()
{
}

BOOL XMF_Control::IsAllowDirectUnite(MF_Class class1, MF_Class class2)
{
	ASSERT(class1 >= GROUND_FIRST && class1 <= GROUND_LAST);
	ASSERT(class2 >= GROUND_FIRST && class2 <= GROUND_LAST);
	ASSERT(class1 != class2);

	return x_IndirectUnite[class1][class2] == -1;
}

MF_Class XMF_Control::FindBestIndirectUnite(MF_Class from, MF_Class to)
{
	ASSERT(from >= GROUND_FIRST && from <= GROUND_LAST);
	ASSERT(to >= GROUND_FIRST && to <= GROUND_LAST);
	ASSERT(from != to);
	ASSERT(x_IndirectUnite[from][to] >= 0);

	return x_IndirectUnite[from][to];
}

BOOL XMF_Control::IsValidatePos(int x, int y)
{
	// !!!  (x,y) ǷϷĴ
}

void XMF_Control::GetMapData(int x, int y, MF_Class aClass[4])
{
	MAP_GROUND_DATA_STRUCT groundData;

	// !!! ѵͼ (x,y)  groundData Ĵ

	UnpackGround(groundData, aClass);
}

void XMF_Control::SetMapData(int x, int y, const MF_Class aClass[4])
{
	MAP_GROUND_DATA_STRUCT groundData;

	PackGround(groundData, aClass);

	// !!!  groundData  ͼ (x,y) Ĵ
	// !!! ңͼ (x,y) Ӧػ
}

/*
ʹ÷

	// 1. ʼ
	XIMapFill *pMapFill = MF_Create();
	XIMapFillControl *pMFControl = new XMF_Control;

	// 2. Զĳһ㣺
	pMapFill->AutoMapFill(pMFControl, x, y, cls, 1);

	// 3. ʱ
	delete pMFControl;
	delete pMapFill;
*/
