/////////////////
// X_PS.h		:	A* ·㷨ͷļ
// X_PS.h		:	Header file of A* path searching algorithm
//
// 汾0010		:	һžʮʮһ
// v0010		:	Oct.31.1997
//
// д			:	л
// written by	:	JianHua Xie
//
// 		:	Visual C++ 4.0
// Compiler		:	Visual C++ 4.0
//
// Ȩ			:	ǰ޹˾	1997
// Copyright(C)	:	WayAhead Co. Ltd.		1997
//
/////////////////
//
// ļ A* ·㷨ݽṹඨ塣
//

#ifndef __X_PS_H__
#define __X_PS_H__

#include "PS_INT.h"
#include "X_TMPL.h"

/////////////////////
// XPS_Node: ڵṹ
// 
struct XPS_Node {
	PS_Pos Pos;				// ڵλ 
							// the location on the map
	XPS_Node *Parent;		// 뱾ڵǰһڵ
							// the node that move to here
	XPS_Node *HashNext;		// ӴձʹãͬͰڵĽڵ 
							// the hash link to next node
	PS_Cost ActualCost;		// ɿʼ㵽ﱾڵʱ˶
							// The actual cheapest cost of arriving at this
							// node from the start node.
	PS_Cost EstimateCost;	// ɱڵ㵽Ŀ۵Ĺֵ
							// The heuristic estimate of the cost to the goal
							// from this node.
//	short Length;			// ɿʼ㵽ﱾڵ㾭˶ٸڵ
							// The length of path up to this position
	PS_Dir DirFromParent;	// ǰһڵǸ򵽴ﱾڵ
							// The direction from arent to this node
	PS_DirMask VisitedDirs;	// ʾЩĽڵѱʹ
							// The directions that already visited

public:
	PS_Cost GetScore() const;
};
 
class XPathSearch : public PS_Interface {
protected:
	enum { PS_HASHBACKET_SIZE = 256, };

	XPS_Node *m_pNearstNode;

	XPS_Node **m_pOpenList;	// the node index of open list, order by node score
	unsigned m_OpenListLimit;
	unsigned m_OpenListCount;

	XStructAllocator<XPS_Node, 32> m_Nodes;

	XPS_Node *m_aBacket[PS_HASHBACKET_SIZE];	// backet of the hash table

public:
	XPathSearch();

	virtual ~XPathSearch();

public:
	// override PS_Interface virtual's
	//
	virtual int FindPath(PS_Pos posSrc, PS_Control* pControl, unsigned cDepth = 0);
	virtual unsigned GetDirResult(PS_Dir *paDirs, unsigned cSize);
	virtual unsigned GetPosResult(PS_Pos *paPos, unsigned cSize);
	virtual unsigned GetImmediateStatus(void *lpBuf, unsigned cSize);
	virtual int IncreaseFind(const void *lpImmStatus, unsigned cSize,
							 PS_Control* pControl, unsigned cDepth = 0);
	virtual void FlushResult();
	virtual void PackMemory();

public:
	BOOL ResultValid() const;

	unsigned GetReachedNodeCount() const;
	const XPS_Node *GetReachedNode(unsigned index) const;

	const XPS_Node *GetNearstNode() const;
	static const XPS_Node *GetPrevNode(const XPS_Node *node);
	unsigned GetPathLength() const;
	PS_Cost GetPathCost() const;

protected:
	void Flush();
	void Cleanup();

	XPS_Node *FindReachedNode(const PS_Pos& pos) const;

	XPS_Node *PushNode(PS_Pos pos, XPS_Node *pParent, PS_Dir dirFromParent,
		PS_Cost actualCost, PS_Cost estimateCost, PS_DirMask visitedDirs);
	XPS_Node *PopupNode();

	int  OpenList_Grow(unsigned delta);
	void OpenList_Heapify(unsigned curr);
	void OpenList_Pullup(unsigned curr);

	XPS_Node *FindNearstNode() const;
};

////////////////////////////////////////////////////////////////////////////////
// Ƕʵ֣
//
inline PS_Cost XPS_Node::GetScore() const
{
	return ActualCost + EstimateCost;
}

inline unsigned XPathSearch::GetReachedNodeCount() const
{
	return m_Nodes.GetCount();
}

inline const XPS_Node *XPathSearch::GetReachedNode(unsigned index) const
{
	return m_Nodes.Get(index);
}

inline BOOL XPathSearch::ResultValid() const
{
	return m_pNearstNode != NULL;
}

inline const XPS_Node *XPathSearch::GetNearstNode() const
{
	return m_pNearstNode;
}
	
inline const XPS_Node *XPathSearch::GetPrevNode(const XPS_Node* node)
{
	ASSERT(node != NULL);
	return node->Parent;
}

/*
inline int XPathSearch::GetPathLength() const
{
	return GetNearstNode()->Length;
}
*/

inline PS_Cost XPathSearch::GetPathCost() const
{
	return GetNearstNode()->ActualCost;
}

#endif /* __X_PS_H__ */
