/////////////////
// X_TMPL.h		:	ͨݽṹģ
// X_TMPL.h		:	General data structure type template
//
// 汾0010		:	һžʮ¶ʮ
// v0010		:	Oct.29.1997
//
// д			:	л
// written by	:	JianHua Xie
//
// 		:	Visual C++ 4.0
// Compiler		:	Visual C++ 4.0
//
// Ȩ			:	ǰ޹˾	1997
// Copyright(C)	:	WayAhead Co. Ltd.		1997
//
/////////////////
//
// ļһЩݽṹ͵ģʵ֡
//

#ifndef __X_TMPL_H__
#define __X_TMPL_H__

////////////////////////////////////////////////////////////////////////////////
//
// template <class T, unsigned COUNT> class XStructAllocator
// ṹģ
//   
//	:
//		ĳЩ㷨ʵо̬һЩС͵ݣЩ
//	ڴһķȥͷȴһġΪ˱ C/C++
//	ڴĵЧͬʱҲΪ㷨ʵֹвñ㷨
//	ʵϸԻ࣬ģ塣
//
////////////////////////////////////////////////////////////////////////////////

template <class T, unsigned COUNT>
class XStructAllocator {
protected:
	struct XChunk {
		XChunk *Next;
		T Data[COUNT];
	};

	XChunk *m_pFirst;
	XChunk *m_pLast;
	unsigned m_Index;
	unsigned m_Count;

public:
	XStructAllocator();
	~XStructAllocator();
	
	void	Cleanup();
	void	Flush();
	T*		Alloc();

	unsigned	GetCount() const;
	T*		Get(unsigned index) const;
	T*		operator[](unsigned index) const;
};

template <class T, unsigned COUNT> 
inline unsigned XStructAllocator<T, COUNT>::GetCount() const
	{ return m_Count; }

template <class T, unsigned COUNT> 
inline T *XStructAllocator<T, COUNT>::operator[](unsigned index) const
	{ return Get(index); }

template <class T, unsigned COUNT> 
T *XStructAllocator<T, COUNT>::Get(unsigned index) const
{
	ASSERT(index >= 0 && index < m_Count);
	XChunk *p = m_pFirst;
	while (index >= COUNT) {
		ASSERT(p != NULL);
		index -= COUNT;
		p = p->Next;
	}
	return p->Data + index;
}

template <class T, unsigned COUNT> 
T *XStructAllocator<T, COUNT>::Alloc()
{
	if (m_Index >= COUNT) {
		ASSERT(m_Index == COUNT);

		if (m_pLast == NULL) {
			ASSERT(m_pFirst == NULL);
			m_pFirst = m_pLast = new XChunk;
			m_pLast->Next = NULL;
		} else if (m_pLast->Next == NULL) {
			ASSERT(m_pFirst != NULL);
			m_pLast->Next = new XChunk;
			m_pLast = m_pLast->Next;
			m_pLast->Next = NULL;
		} else {
			ASSERT(m_pFirst != NULL);
			m_pLast = m_pLast->Next;
		}

		m_Index = 0;
	}


	ASSERT(m_pLast != NULL);
	ASSERT(m_Index >= 0 && m_Index < COUNT);

	T *result = m_pLast->Data + m_Index;
	m_Count++;
	m_Index++;
	return result;	
}

template <class T, unsigned COUNT> 
inline void XStructAllocator<T, COUNT>::Flush()
{
	m_Count = 0;
	m_pLast = m_pFirst;
	if (m_pLast)
		m_Index = 0;
	else
		m_Index = COUNT;
}

template <class T, unsigned COUNT> 
void XStructAllocator<T, COUNT>::Cleanup()
{
	XChunk *p = m_pFirst;
	while (p != NULL) {
		XChunk *pNext = p->Next;
		delete p;
		p = pNext;
	}

	m_pFirst = NULL;
	m_pLast  = NULL;
	m_Count  = 0;
	m_Index  = COUNT;
}

template <class T, unsigned COUNT> 
inline XStructAllocator<T, COUNT>::XStructAllocator()
{
	m_pFirst = NULL;
	m_pLast  = NULL;
	m_Count  = 0;
	m_Index  = COUNT;
}

template <class T, unsigned COUNT> 
inline XStructAllocator<T, COUNT>::~XStructAllocator()
{
	Cleanup();
}

#endif /* __XTMPL_H__ */
